#include <dbus/dbus.h>

struct oddjob_dbus_context;
struct oddjob_dbus_message;

/* Server */
struct oddjob_dbus_context *oddjob_dbus_listener_new(const char *service_name);
void oddjob_dbus_listener_free(struct oddjob_dbus_context *ctx);
typedef void (oddjob_dbus_handler)(struct oddjob_dbus_context *ctx,
				   struct oddjob_dbus_message *msg,
				   const char *user,
				   unsigned long uid,
				   void *data);
void        oddjob_dbus_listener_add_method(struct oddjob_dbus_context *ctx,
					    const char *object_path,
					    const char *interface,
					    const char *method,
					    int n_arguments,
					    oddjob_dbus_handler *handler,
					    void *data);

int oddjob_dbus_message_get_n_args(struct oddjob_dbus_message *msg);
const char *oddjob_dbus_message_get_arg(struct oddjob_dbus_message *msg, int n);
void oddjob_dbus_send_message_response_success(struct oddjob_dbus_message *msg,
					       const char *text);
void oddjob_dbus_send_message_response_error(struct oddjob_dbus_message *msg,
					     const char *error,
					     const char *text);
void oddjob_dbus_main_init(struct oddjob_dbus_context *ctx);
void oddjob_dbus_main_done(struct oddjob_dbus_context *ctx);
int oddjob_dbus_main_iterate(struct oddjob_dbus_context *ctx);

/* Clients */
int oddjob_dbus_call_method(const char *service, const char *object_path,
			    const char *interface, const char *method,
			    char *output, size_t output_length,
			    ...);
